function r = balancing_algorithm(t,s,paramSC)

M  = paramSC.Mass; 
Jn = paramSC.J;
Dt = t(2)-t(1);

% Delta t used in the CM estimate algorithm
Dt_sample = 0.05;

% initialize cont_sample
cont_sample = 1;

for iT = 1:numel(t)
    if rem(t(iT)+Dt/2,Dt_sample)<Dt
        
        pitch = s(iT,1);
        roll  = s(iT,2);
        wx    = s(iT,3);
        wy    = s(iT,4);
        wz    = s(iT,5);
        
        if iT == 1
            pitch1 = pitch; roll1 = roll;
            w1x = wx; w1y = wy; w1z = wz;
        else
            pitch2 = pitch; roll2 = roll;
            w2x = wx; w2y = wy; w2z = wz;

            F12(cont_sample) = -M*9.81*Dt_sample/2/Jn(1,1)*(cos(roll2)*cos(pitch2)+cos(roll1)*cos(pitch1));
            F13(cont_sample) =  M*9.81*Dt_sample/2/Jn(1,1)*(sin(roll2)*cos(pitch2)+sin(roll1)*cos(pitch1));
            F21(cont_sample) =  M*9.81*Dt_sample/2/Jn(2,2)*(cos(roll2)*cos(pitch2)+cos(roll1)*cos(pitch1));
            F23(cont_sample) =  M*9.81*Dt_sample/2/Jn(2,2)*(sin(pitch2)+sin(pitch1));
            F31(cont_sample) = -M*9.81*Dt_sample/2/Jn(3,3)*(sin(roll2)*cos(pitch2)+sin(roll1)*cos(pitch1));
            F32(cont_sample) = -M*9.81*Dt_sample/2/Jn(3,3)*(sin(pitch2)+sin(pitch1));
            Domegas(:,cont_sample) = [w2x-w1x; w2y-w1y; w2z-w1z];

            roll1 = roll2; pitch1 = pitch2; 
            w1x = w2x; w1y = w2y; w1z = w2z;

            cont_sample = cont_sample + 1;
        end
    end 
end

%% Estimate algorithm
FI = [];
Dw = [];
for iS = 1:size(F12,2)
    FI = [FI; 0 F12(iS) F13(iS); F21(iS) 0 F23(iS); F31(iS) F32(iS) 0];
    Dw = [Dw; Domegas(:,iS)];
end
r = -FI\Dw;

