function [t,x] = dynamic_model(initialConds, paramSC)

RG_SC = paramSC.RG;
J_SC  = paramSC.J;
M_SC  = paramSC.Mass;

phi0   = initialConds.orient(1);
theta0 = initialConds.orient(2);
psi0   = initialConds.orient(3);
omegax0 = initialConds.omega(1);
omegay0 = initialConds.omega(2);
omegaz0 = initialConds.omega(3);

simTime = 60;    %[sec]
tRes    = .005;  %[sec]

tspan = (0:tRes:simTime);
[t,x] = ode45(@(t,x)euler_equations_RPY(t,x,J_SC,M_SC,RG_SC),tspan,[phi0 theta0 psi0 omegax0 omegay0 omegaz0]');
    

