function visualize_motion(t,x,paramSC,meshModel)

load(meshModel);

alim = .3;

figure(2), axis equal, box on, view(3)
set(gcf,'color','w')
          
for iS = 1:size(x,1)
    
    phi   = x(iS,1);
    theta = x(iS,2);
    psi   = x(iS,3);
    wx = x(iS,4);
    wy = x(iS,5);
    wz = x(iS,6);
    
    R = [cos(phi)*cos(theta) sin(phi)*cos(theta) -sin(theta); ...
         cos(phi)*sin(theta)*sin(psi)-sin(phi)*cos(psi) sin(phi)*sin(theta)*sin(psi)+cos(phi)*cos(psi) cos(theta)*sin(psi); ...
         cos(phi)*sin(theta)*cos(psi)+sin(phi)*sin(psi) sin(phi)*sin(theta)*cos(psi)-cos(phi)*sin(psi) cos(theta)*cos(psi)]';

    % calculate patch
    hemisphere_grid_ = R*hemisphere_grid';
    platform_grid_ = R*platform_grid';
    RG_SC       = R*paramSC.RG;
    
    figure(2), cla, hold on, box on
    set(gca,'color',[.95 .95 .95],'XTick',{},'YTick',{},'ZTick',[],'xlim',[-alim alim],'ylim',[-alim alim],'zlim',[-alim alim])

    % plot patch
    patch('Faces',hemisphere_face,'Vertices',hemisphere_grid_','facecolor','w','facealpha',.8)
    patch('Faces',platform_face,'Vertices',platform_grid_','facecolor','w','facealpha',.8)
    plot3(0,0,0,'ob')
    plot3(0,0,0,'.b')
    plot3(RG_SC(1),RG_SC(2),RG_SC(3),'r+')
        
    pause(.01)
    
    title(['Time [s] = ' num2str(t(iS))],'horizontalalignment','left')

    if ~ishandle(2), break, end
end
